// merge
`include "global.vh"
module xmas_merge (clk, rst,
    a$irdy, a$trdy, a$data,
    b$irdy, b$trdy, b$data,
    o$irdy, o$trdy, o$data);

input clk, rst;

input a$irdy;
output a$trdy;
input [`DATA_WIDTH-1:0] a$data;

input b$irdy;
output b$trdy;
input [`DATA_WIDTH-1:0] b$data;

output o$irdy;
input o$trdy;
output [`DATA_WIDTH-1:0] o$data;
    
// arbitration state
reg preU;
reg transfer;
wire u;
assign u = a$irdy && !(b$irdy) ? 1'b1 : (!(a$irdy) && b$irdy ? 0 : (transfer ? !preU : preU));

always @(posedge clk) preU<=rst?1'b0:u;
always @(posedge clk) transfer<=o$irdy && o$trdy;

assign o$irdy = a$irdy || b$irdy;
assign o$data = (u && a$irdy)? a$data : b$data;
assign a$trdy = u && o$trdy && a$irdy;
assign b$trdy = !u && o$trdy && b$irdy;
endmodule
